## pegasus-wms 4.0.1+dfsg

=== doc/docbook/Makefile ===

ifndef ${prefix}
prefix = html
endif

all: ${prefix}/index.php ${prefix}/pegasus-user-guide.pdf ${prefix}/basic-properties.pdf ${prefix}/advanced-properties.pdf

configuration.xml: ../../etc/basic.properties ../../libexec/docbook-sample-props
	export PEGASUS_HOME=`dirname \`pwd ../../\`` \
        && ../../libexec/docbook-sample-props ../../etc/basic.properties > configuration.xml 

reference_properties.xml: ../../etc/advanced.properties ../../libexec/docbook-sample-props
	export PEGASUS_HOME=`dirname \`pwd ../../\`` \
	    && ../../libexec/docbook-sample-props ../../etc/advanced.properties > reference_properties.xml 

${prefix}/index.php: *.xml pegasus-style.xsl configuration.xml reference_properties.xml
	mkdir -p ${prefix}/images
	xsltproc --noout \
		      --stringparam base.dir ${prefix}/ \
		      --xinclude \
	         pegasus-style.xsl \
	         pegasus-book.xml
	cp images/*.png images/*.jpg ${prefix}/images/

pegasus-user-guide.fo: *.xml pegasus-pdf-style.xsl
	xsltproc --xinclude pegasus-pdf-style.xsl pegasus-book.xml > pegasus-user-guide.fo

basic-properties.fo: *.xml pegasus-pdf-style.xsl
	xsltproc --xinclude pegasus-pdf-style.xsl basic-properties-book.xml > basic-properties.fo

advanced-properties.fo: *.xml pegasus-pdf-style.xsl
	xsltproc --xinclude pegasus-pdf-style.xsl advanced-properties-book.xml > advanced-properties.fo

${prefix}/pegasus-user-guide.pdf: pegasus-user-guide.fo
	fop pegasus-user-guide.fo -pdf pegasus-user-guide.pdf
	cp pegasus-user-guide.pdf ${prefix}/

${prefix}/basic-properties.pdf: basic-properties.fo
	fop basic-properties.fo -pdf basic-properties.pdf
	cp basic-properties.pdf ${prefix}/

${prefix}/advanced-properties.pdf: advanced-properties.fo
	fop advanced-properties.fo -pdf advanced-properties.pdf
	cp advanced-properties.pdf ${prefix}/

clean:
	  rm -rf html *.fo *.pdf ./*~

=== src/tools/Makefile ===
#
# build all C/C++ sources 
#
# $Id: Makefile 5027 2012-02-27 23:59:50Z voeckler $
#
TARGET	= pegasus-cluster pegasus-invoke pegasus-keg pegasus-kickstart
CONDOR_VERSION	= $(shell condor_version | awk '{ print $2; exit }')
MARCH   = $(shell uname -m | tr '[A-Z]' '[a-z]')

ifndef ${prefix}
prefix = $(PEGASUS_HOME)
endif

.ONESHELL:
all clean distclean install:
	for i in $(TARGET); do \
	    if [ -d $$i ]; then \
		$(MAKE) -C $$i $@ || exit 1; \
	    fi; \
	done

=== share/man/man1/Makefile ===
#
# make documentation
#
PS2PDF	= ps2pdf14
NROFF	= groff -mandoc
TEXT	= -Tlatin1
HTML	= -Thtml
# use /usr/ucb/install on Solaris
INSTALL	= install

SRC	= pegasus-analyzer.1 \
	pegasus-cleanup.1 \
	pegasus-create-dir.1 \
	pegasus-dax-validator.1 \
	pegasus-exitcode.1 \
	pegasus-monitord.1 \
	pegasus-plan.1 \
	pegasus-plots.1 \
	pegasus-rc-client.1 \
	pegasus-remove.1 \
	pegasus-run.1 \
	pegasus-s3.1 \
	pegasus-sc-client.1 \
	pegasus-sc-converter.1 \
	pegasus-statistics.1 \
	pegasus-status.1 \
	pegasus-tc-client.1 \
	pegasus-tc-converter.1 \
	pegasus-transfer.1 \
	pegasus-version.1

OUTPS	= $(SRC:.1=.ps)
OUTPDF	= $(SRC:.1=.pdf)
OUTTXT	= $(SRC:.1=.txt)
OUTHTML	= $(SRC:.1=.html)

%.html : %.1 ;
	$(NROFF) $(HTML) $< > $@
%.ps : %.1 ;
	$(NROFF) $< > $@
%.pdf : %.1 ;
	$(NROFF) $< | $(PS2PDF) > $@
%.txt : %.1
	$(NROFF) $(TEXT) $< > $@

all : all-ps all-txt all-html

all-ps : $(OUTPS)
all-txt : $(OUTTXT)
all-html : $(OUTHTML)

install: all
	@test "$PEGASUS_HOME" || exit 1
#	$(INSTALL) -m 0644 $(SRC) $(PEGASUS_HOME)/man/man1
	$(INSTALL) -m 0644 $(OUTPS) $(PEGASUS_HOME)/man
	$(INSTALL) -m 0644 $(OUTTXT) $(PEGASUS_HOME)/man
	$(INSTALL) -m 0644 $(OUTHTML) $(PEGASUS_HOME)/man

clean : 
	rm -f $(OUTPS) $(OUTTXT) $(OUTHTML)

=== src/tools/pegasus-cluster/Makefile ===
#
# Makefile
# $Id: Makefile 5027 2012-02-27 23:59:50Z voeckler $
#
INSTALL	= install
RM	= rm -f
CC	= gcc
CXX	= g++
SYSTEM  = $(shell uname -s | tr '[a-z]' '[A-Z]' | tr -d '_ -/')
VERSION = $(shell uname -r)
MARCH	= $(shell uname -m | tr '[A-Z]' '[a-z]')
MAJOR   = $(firstword $(subst ., ,$(VERSION)))
LOADLIBES = -lm

ifndef ${prefix}
prefix	= $(PEGASUS_HOME)
endif

ifndef ${datadir}
datadir = $(prefix)/share 
endif

ifeq (SUNOS,${SYSTEM})
ifeq (5,${MAJOR})
CC	= cc
CXX	= CC
V7FLAGS	= -xtarget=generic
V9FLAGS	= -xtarget=ultra -xarch=v9
CFLAGS	= -dalign -ftrap=%none -fsimple -xlibmil $(EXTRACFLAGS)
CFLAGS := -DSOLARIS $(CFLAGS) -xO4 -D__EXTENSIONS__=1
LDFLAGS	+= $(EXTRACFLAGS)
INSTALL	= /usr/ucb/install
LOADLIBES += -lnsl
else
# old Solaris 1 not supported
endif
endif

ifeq (AIX,${SYSTEM})
CXX	= xlC
CC	= xlc
endif

ifeq (LINUX,${SYSTEM})
CFLAGS	:= -Wall -O2 -ggdb
ifeq (ia64,${MARCH})
#
# Linux IA64
#
CFLAGS	+= -DMARCH_IA64=1
else
ifeq (x86_64,${MARCH})
#
# Linux AMD64
#
CFLAGS	+= -m64
else
ifeq (armv7l, ${MARCH})
# nothing to do
else
#
# Linux IA32
#
CFLAGS	+= -march=i686
# LDFLAGS	+= -static
endif
endif
endif
endif

#
# === [3] ======================================================= rules section
# There is no need to change things below this line.
CFLAGS	+= -D${SYSTEM} -DMAJOR=${MAJOR}
LD	= $(CC) -D_FILE_OFFSET_BITS=64
CC	+= -D_FILE_OFFSET_BITS=64
CFLAGS	+= -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE

%.html : %.1 ;
	$(NROFF) $(HTML) $< > $@
%.ps : %.1 ;
	$(NROFF) $< > $@
%.txt : %.1 ;
	$(NROFF) $(TEXT) $< > $@
%.o : %.c
	$(CC) $(CFLAGS) $< -c -o $@

all: pegasus-cluster

job.o: job.c job.h
mysystem.o: mysystem.c tools.h report.h mysystem.h
parser.o: parser.c parser.h tools.h
report.o: report.c tools.h report.h
pegasus-cluster.o: pegasus-cluster.c tools.h parser.h report.h mysystem.h \
  job.h statinfo.h
statinfo.o: statinfo.c statinfo.h
tools.o: tools.c tools.h
try-cpus.o: try-cpus.c

pegasus-cluster: pegasus-cluster.o tools.o parser.o report.o mysystem.o \
	job.o statinfo.o 
	$(LD) $(LDFLAGS) $^ -o $@ $(LOADLIBES)

try-cpus: try-cpus.o
	$(LD) $(LDFLAGS) $^ -o $@ $(LOADLIBES)

install: pegasus-cluster
	$(INSTALL) -m 0755 $^ $(prefix)/bin

check:	pegasus-cluster
	bash check.sh

clean:
	$(RM) *.o core core.* check.?

distclean: clean
	$(RM) pegasus-cluster try-cpus

=== src/tools/pegasus-kickstart/Makefile ===
#
# Makefile 
#
INSTALL	= install
RM	= rm -f
CC	= gcc
CFLAGS	= -O
LD	= $(CC)
LOADLIBES = -lm
SYSTEM  = $(shell uname -s | tr '[a-z]' '[A-Z]' | tr -d '_ -/')
VERSION = $(shell uname -r)
MARCH	= $(shell uname -m | tr '[A-Z]' '[a-z]')
MAJOR   = $(firstword $(subst ., ,$(VERSION)))
MINOR   = $(strip $(word 2,$(subst ., ,$(VERSION))))
EXTRA_OBJ = machine/basic.o 
SOCKIO  = $(shell /bin/ls /usr/include/sys/sockio.h 2>/dev/null)
LFS_CFLAGS = -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE 
LFS_LDFLAGS = 

ifndef ${prefix}
prefix = $(PEGASUS_HOME)
endif

ifndef ${datadir}
datadir = $(prefix)/share 
endif

ifeq (SUNOS,${SYSTEM})
ifeq (5,${MAJOR})
# use these for the SUN CC compiler
CC	= cc
LD	= $(CC)
## SPARCv7
LFS_CFLAGS = $(shell getconf LFS_CFLAGS 2>>/dev/null)
LFS_LDFLAGS = $(shell getconf LFS_LDFLAGS 2>>/dev/null)
V7FLAGS	= -xtarget=generic
V9FLAGS	= -xtarget=ultra -xarch=v9
CFLAGS  = -dalign -ftrap=%none -fsimple -xlibmil $(EXTRACFLAGS)
#EXTRACFLAGS = $(V7FLAGS)
CFLAGS := -DSOLARIS $(CFLAGS) -xO4 -D__EXTENSIONS__=1
LOADLIBES += -lkstat -lnsl -lsocket
INSTALL = /usr/ucb/install
EXTRA_OBJ += machine/sunos-swap.o machine/sunos.o 
else
# old Solaris 1 not supported!
endif
endif

ifeq (IRIX64,${SYSTEM})
# The regular 64bit Irix stuff is just too slow, use n32!
SYSTEM        := IRIX
endif

ifeq (IRIX,${SYSTEM})
CC      = cc -n32 -mips3 -r4000
LD      = $(CC)
OPT_NORM = -O3 -IPA -LNO:opt=1
endif

ifeq (AIX,${SYSTEM})
CC	= xlc
CXX	= xlC
endif

ifeq (DARWIN,${SYSTEM})
#CFLAGS	+= -DDEBUG_WAIT=1 -DDEBUG_EVENTLOOP=1
CFLAGS	+= -DMUST_USE_SELECT_NOT_POLL=1 -DHAS_REALPATH_EXT=1 -ggdb
LOADLIBES += -ggdb
EXTRA_OBJ += machine/darwin.o
endif

ifeq (CYGWINNT,$(findstring CYGWINNT,${SYSTEM}))
CFLAGS	+= -DSYS_NMLN=20 -DCYGWIN=1
CFLAGS	+= -DDEBUG_EVENTLOOP=1 -DDEBUG_WAIT=1
endif

ifeq (LINUX,${SYSTEM})
ifeq (ia64,${MARCH})
# old Intel-only IA64 architecture
CFLAGS	= -Wall -O2 -ggdb
else
ifeq (x86_64,${MARCH})
# new Intel/AMD 64bit architecture
CFLAGS	= -Wall -O2 -ggdb -m64
else
ifeq (i686,${MARCH})
# regular 32bit x86 architecture
CFLAGS	= -Wall -O2 -march=i686 -ggdb
else
# UNKNOWN ARCHITECTURE -- MAKE NO ASSUMPTIONS
CFLAGS	= -Wall -O2 -ggdb
endif
endif
endif
#CFLAGS	+= -D__USE_POSIX=199309
#LOADLIBES += -Wl,-Bstatic -lefence -Wl,-Bdynamic 
LFS_CFLAGS = $(shell getconf LFS_CFLAGS 2>>/dev/null)
LFS_LDFLAGS = $(shell getconf LFS_LDFLAGS 2>>/dev/null)
EXTRA_OBJ += machine/linux.o 
CFLAGS += -DHAS_REALPATH_EXT=1
endif

#
# === [3] ======================================================= rules section
# There is no need to change things below this line.
CFLAGS += -D${SYSTEM} -DMAJOR=${MAJOR} -DWITH_NEW_ARGS=1 # -DSOCKLEN=${SOCKLEN}
ifneq (,${SOCKIO})
CFLAGS += -DHAS_SYS_SOCKIO=1
endif
CFLAGS += -DUSE_PARSE=1 # -ggdb

# add large file support
ifneq (,${LFS_CFLAGS})
NOLFS_CFLAGS := $(CFLAGS)
CFLAGS += $(LFS_CFLAGS)
endif
ifneq (,${LFS_LDFLAGS})
LDFLAGS += $(LFS_LDFLAGS)
endif

%.o : %.c
	$(CC) $(CFLAGS) $< -c -o $@

all : pegasus-kickstart

pegasus-kickstart: debug.o getif.o rwio.o tools.o useinfo.o mynss.o statinfo.o event.o jobinfo.o limitinfo.o $(EXTRA_OBJ) machine.o appinfo.o parse.o mysystem.o mylist.o invoke.o pegasus-kickstart.o
	$(LD) $(EXTRA_LDFLAGS) $(CFLAGS) $^ -o $@ $(LOADLIBES)
show-if: show-if.o getif.o debug.o
	$(LD) $(EXTRA_LDFLAGS) $(CFLAGS) $^ -o $@ $(LOADLIBES)
try-parse: try-parse.o parse.o
	$(LD) $(EXTRA_LDFLAGS) $(CFLAGS) $^ -o $@ $(LOADLIBES)

appinfo.o: appinfo.c getif.h rwio.h debug.h tools.h useinfo.h machine.h \
  jobinfo.h statinfo.h appinfo.h limitinfo.h mynss.h
debug.o: debug.c debug.h rwio.h
event.o: event.c rwio.h debug.h tools.h event.h statinfo.h mysignal.h
fail.o: fail.c
getif.o: getif.c debug.h getif.h
invoke.o: invoke.c invoke.h
jobinfo.o: jobinfo.c getif.h debug.h tools.h useinfo.h jobinfo.h \
  statinfo.h parse.h
pegasus-kickstart.o: pegasus-kickstart.c rwio.h debug.h appinfo.h \
  statinfo.h jobinfo.h limitinfo.h machine.h mysystem.h mylist.h \
  invoke.h tools.h
limitinfo.o: limitinfo.c debug.h tools.h limitinfo.h
machine.o: machine.c machine.h machine/basic.h debug.h
meminfo.o: meminfo.c meminfo.h debug.h
msave.o: msave.c machine.h debug.h tools.h
mylist.o: mylist.c mylist.h
mynss.o: mynss.c mynss.h
mysystem.o: mysystem.c debug.h tools.h appinfo.h statinfo.h jobinfo.h \
  limitinfo.h machine.h event.h mysystem.h mysignal.h
parse.o: parse.c debug.h parse.h
rwio.o: rwio.c rwio.h
show-if.o: show-if.c getif.h
statinfo.o: statinfo.c mynss.h debug.h statinfo.h tools.h
test-ascii.o: test-ascii.c
test-post.o: test-post.c
test-pre.o: test-pre.c
tools.o: tools.c tools.h
try-parse.o: try-parse.c parse.h
useinfo.o: useinfo.c tools.h useinfo.h
zio.o: zio.c zio.h

machine/basic.o: machine/basic.c machine/basic.h machine/../tools.h
machine/sunos.o: machine/sunos.c machine/basic.c machine/sunos.h \
  machine/sunos-swap.h machine/../tools.h
machine/sunos-swap.o: machine/sunos-swap.c machine/sunos-swap.h
	$(CC) $(NOLFS_CFLAGS) $< -c -o $@
machine/linux.o: machine/linux.c machine/basic.c machine/linux.h \
  machine/../tools.h
machine/darwin.o: machine/darwin.c machine/basic.c machine/darwin.h \
  machine/../tools.h

install: pegasus-kickstart
	$(INSTALL) -m 0755 pegasus-kickstart $(prefix)/bin

clean:
	$(RM) *.o machine/*.o core core.*

distclean: clean
	$(RM) pegasus-kickstart fail test-post test-pre test-ascii show-if

=== src/tools/replanner/Makefile ===
#
# Makefile 
#
INSTALL	= install
NROFF   = groff -mandoc
TEXT    = -Tlatin1
HTML    = -Thtml

GENDOC = replanner.html replanner.txt replanner.ps

%.html : %.1 ;
	$(NROFF) $(HTML) $< > $@
%.ps : %.1 ;
	$(NROFF) $< > $@
%.txt : %.1 ;
	$(NROFF) $(TEXT) $< > $@

install: $(GENDOC)
	$(INSTALL) -m 0755 replanner $(PEGASUS_HOME)/bin
	$(INSTALL) -m 0644 $(GENDOC) $(PEGASUS_HOME)/man
	$(INSTALL) -m 0644 replanner.1 $(PEGASUS_HOME)/man/man1

doc: $(GENDOC)

clean:
	$(RM) $(GENDOC) core

distclean: clean

=== src/tools/T2/doc/Makefile ===
#
# make for LaTeX
#
LATEX	= latex
#PS2PDF	= ps2pdf14
PS2PDF	= ps2pdf -sPAPERSIZE=letter
DVIPS	= dvips
PRTGIF	= tgif -print
RM	= rm -f

%.pdf : %.ps
	$(PS2PDF) $< $@
%.ps : %.dvi
	$(DVIPS) $< -o $@
%.eps : %.obj
	$(PRTGIF) -adobe=3.0/1.2 -eps $< 

all : T2.pdf

#SRC	= euryale.obj partition.obj pegasus.obj sphinx.obj
#EPS	= $(SRC:.obj=.eps)

T2.pdf : T2.ps
T2.ps : T2.dvi
T2.dvi : T2.tex $(EPS)
	$(LATEX) $<
	$(LATEX) $<

clean:
	$(RM) T2.aux T2.log T2.out T2.toc T2.ps

distclean: clean
	$(RM) $(EPS) T2.pdf T2.dvi

=== debian/control ===
Source: pegasus-wms
Section: science
Priority: optional
Maintainer: Mats Rynge <mats@rynge.net>
Build-Depends: debhelper (>= 9), 
               openjdk-7-jdk,
               ant,
               docbook-xsl,
               docbook-xml,
               asciidoc,
               xsltproc,
               fop,
               perl,
               python,
               python-dev,
               libcommons-logging-java,
               libcommons-pool-java,
               libgetopt-java,
               liblog4j1.2-java,
               libmysql-java,
               libxml-commons-resolver1.1-java,
               libxerces2-java,
               libxmlrpc3-common-java
Standards-Version: 3.9.3
Homepage: http://pegasus.isi.edu

Package: pegasus-wms
Section: science
Priority: optional
Architecture: any
Depends: java7-runtime | java6-runtime,
         perl,
         python,
         python-boto,
         python-sqlalchemy,
         libcommons-logging-java,
         libcommons-pool-java,
         libgetopt-java,
         liblog4j1.2-java,
         libmysql-java,
         libxml-commons-resolver1.1-java,
         libxerces2-java,
         libxmlrpc3-common-java,
         ${shlibs:Depends}, ${misc:Depends}
Recommends: condor
Suggests: pegasus-wms-doc
Description: Scientific workflow management system for Condor
 The Pegasus project encompasses a set of technologies the help
 workflow-based applications execute in a number of different
 environments including desktops, campus clusters, grids, and now
 clouds. Scientific workflows allow users to easily express
 multi-step computations, for example retrieve data from a
 database, reformat the data, and run an analysis. Once an
 application is formalized as a workflow the Pegasus Workflow
 Management Service can map it onto available compute resources
 and execute the steps in appropriate order.

Package: pegasus-wms-doc
Section: doc
Priority: optional
Architecture: all
Depends: ${misc:Depends}
Recommends: pegasus-wms
Description: Scientific workflow management system for Condor - data files
 The Pegasus project encompasses a set of technologies the help
 workflow-based applications execute in a number of different
 environments including desktops, campus clusters, grids, and now
 clouds. Scientific workflows allow users to easily express
 multi-step computations, for example retrieve data from a
 database, reformat the data, and run an analysis. Once an
 application is formalized as a workflow the Pegasus Workflow
 Management Service can map it onto available compute resources
 and execute the steps in appropriate order.
 .
 This package contains the user documentation.

## pegasus-wms 4.4.0%2Bdfsg

=== src/tools/pegasus-keg/Makefile ===
#
# Makefile 
#
INSTALL = install
RM      = rm -f
CXX	= g++ -ffor-scope 
CXXFLAGS = -O
LD      = $(CXX)
LOADLIBES = -lm
SYSTEM  = $(shell uname -s | tr '[a-z]' '[A-Z]' | tr -d '_ -/')
VERSION = $(shell uname -r)
MARCH	= $(shell uname -m | tr '[A-Z]' '[a-z]')
MAJOR   = $(firstword $(subst ., ,$(VERSION)))
SOCKIO  = $(shell /bin/ls /usr/include/sys/sockio.h 2>/dev/null)
EXTRA_OBJ = basic.o
EXTRA_INC = version.h


ifndef ${prefix}
  prefix = $(PEGASUS_HOME)
endif

ifndef ${datadir}
  datadir = $(prefix)/share 
endif

ifeq (DARWIN,${SYSTEM})
  CXXFLAGS += -DMACHINE_SPECIFIC=darwin
  EXTRA_OBJ += darwin.o
  EXTRA_INC += darwin.hh
else
  ifeq (LINUX,${SYSTEM})
    CXXFLAGS = -Wall -O2 -ggdb -DMACHINE_SPECIFIC=linux
    EXTRA_OBJ += linux.o
    EXTRA_INC += linux.hh
    CFLAGS += $(shell getconf LFS_CFLAGS 2>>/dev/null)
    LDFLAGS += $(shell getconf LFS_LDFLAGS 2>>/dev/null)
  else
    $(error Unsupported system: $(SYSTEM))
  endif
endif

CXXFLAGS += -D${SYSTEM} -DMAJOR=${MAJOR}
ifneq (,${SOCKIO})
  CXXFLAGS += -DHAS_SYS_SOCKIO=1
endif

%.o : %.cc
	$(CXX) $(CXXFLAGS) $< -c -o $@

all: pegasus-keg

pegasus-keg: pegasus-keg.o $(EXTRA_OBJ)
	$(LD) $(LDFLAGS) $^ -o $@ $(LOADLIBES)

pegasus-keg.o: pegasus-keg.cc $(EXTRA_INC)
basic.o: basic.cc basic.hh
darwin.o: darwin.cc darwin.hh basic.hh
linux.o: linux.cc linux.hh basic.hh

version.h:
	$(CURDIR)/genversion.sh > $(CURDIR)/version.h

install: pegasus-keg
	$(INSTALL) -m 0755 pegasus-keg $(prefix)/bin

test check: pegasus-keg
	@./pegasus-keg -o /dev/fd/1 || echo "test failed" && echo "test ok"

clean:
	$(RM) pegasus-keg.o core core.* $(EXTRA_OBJ) $(EXTRA_COBJ)

distclean: clean
	$(RM) pegasus-keg

=== src/tools/pegasus-mpi-cluster/Makefile ===
ifndef prefix
prefix = $(PEGASUS_HOME)
endif
bindir = $(prefix)/bin

CXX = mpicxx
CC = $(CXX)
LD = $(CXX)
CXXFLAGS = -g -Wall -ansi
LDFLAGS = 
RM = rm -f
INSTALL = install
MAKE = make

# Flags for gprof
#CXXFLAGS += -pg
#LDFLAGS += -pg

# Flags for gperftools
#CXXFLAGS += -fno-omit-frame-pointer
#LDFLAGS += -lprofiler

# If you want to call fsyncdata() when a record is written to the 
# rescue log, then enable -DSYNC_RESCUE. If you want to enable
# it when data is written to a collective I/O file, then enable
# -DSYNC_IODATA. This will protect the application in the case
# where the system fails, but it adds quite a lot of overhead
# (typically ~10ms for most disks) per write. In the case of the
# rescue log, enabling SYNC_RESCUE causes PMC to handle no more 
# than about 100 tasks/second. Enabling SYNC_IODATA can reduce
# that even more.
#CXXFLAGS += -DSYNC_IODATA -DSYNC_RESCUE

OS=$(shell uname -s)
ifeq (Linux,$(OS))
  OPSYS = LINUX
  SIGN = 
  LIBNUMA=$(shell /sbin/ldconfig -p | grep libnuma.so)
  NUMAIF=$(shell ls /usr/include/numaif.h)
  ifneq ($(LIBNUMA),)
    ifneq ($(NUMAIF),)
      CXXFLAGS += -DHAS_LIBNUMA
      LDFLAGS += -lnuma
    endif
  endif
endif
ifeq (Darwin,$(OS))
  OPSYS = DARWIN
  SIGN = codesign -s "Pegasus Development" $@ || true
endif
ifndef OPSYS
  $(error Unsupported OS: $(OS))
endif

CXXFLAGS += -D$(OPSYS)

OBJS += strlib.o
OBJS += tools.o
OBJS += failure.o
OBJS += engine.o
OBJS += dag.o
OBJS += master.o
OBJS += worker.o
OBJS += protocol.o
OBJS += mpicomm.o
OBJS += fdcache.o
OBJS += log.o

PROGRAMS += pegasus-mpi-cluster

TESTS += test-strlib
TESTS += test-dag
TESTS += test-log
TESTS += test-engine
TESTS += test-tools
TESTS += test-fdcache
TESTS += test-protocol

.PHONY: clean depends test install check

ifeq ($(shell which $(CXX) || echo n),n)
$(warning To build pegasus-mpi-cluster set CXX to the path to your MPI C++ compiler wrapper)
all:
install:
else
all: $(PROGRAMS) tags
install: $(PROGRAMS)
	$(INSTALL) -m 0755 $(PROGRAMS) $(bindir)
endif

pegasus-mpi-cluster: pegasus-mpi-cluster.o $(OBJS)
	$(LD) $(LDFLAGS) $^ -o $@
	$(SIGN)
test-strlib: test-strlib.o $(OBJS)
test-dag: test-dag.o $(OBJS)
test-log: test-log.o $(OBJS)
test-engine: test-engine.o $(OBJS)
test-tools: test-tools.o $(OBJS)
test-fdcache: test-fdcache.o $(OBJS)
test-protocol: test-protocol.o $(OBJS)

test: $(TESTS) $(PROGRAMS)
ifeq ($(shell which cppcheck || echo n),n)
	echo "Install cppcheck for static analysis"
else
	cppcheck --quiet *.cpp
endif
	test/test.sh

distclean: clean
	$(RM) $(PROGRAMS)

clean:
	$(RM) *.o $(TESTS) version.h

depends:
	g++ -MM *.cpp > depends.mk

version.h:
	$(CURDIR)/../../../release-tools/getversion --header > $(CURDIR)/version.h

ifeq ($(shell which ctags || echo n),n)
tags:
	touch tags
else
tags: *.h *.cpp
	ctags -w *.h *.cpp
endif

include depends.mk
